<template>
	<el-dialog title="选择课件" v-model="dialogVisible" draggable append-to-body destroy-on-close>
		<el-form :model="state.queryParams" ref="ruleDialogFormRef" inline @submit.native.prevent :disabled="state.loading">
			<el-form-item label="课件标题" prop="name">
				<el-input v-model="state.queryParams.name" placeholder="课件标题" clearable @keyup.enter="handleQuery" class="keyword-input" />
			</el-form-item>
			<el-form-item>
				<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
				<el-button @click="resetQuery(ruleDialogFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
			</el-form-item>
		</el-form>
		<vxe-table
			border
			:loading="state.loading"
			:data="state.tableData"
			:sort-config="{ remote: true }"
			:column-config="{ resizable: true }"
			:row-config="{ isHover: true, height: 30, keyField: 'id' }"
			ref="tableRef"
			max-height="500px"
			show-overflow
			:scrollY="{ enabled: true, gt: 100 }"
			@checkbox-change="checkboxChangeEvent"
			:checkbox-config="{ highlight: true, showHeader: false }"
		>
			>
			<vxe-column type="checkbox" fixed="left" width="70" align="center"></vxe-column>
			<vxe-column field="name" title="课件标题" min-width="200"></vxe-column>
		</vxe-table>
		<pagination
			@pagination="queryList"
			:total="state.total"
			v-model:current-page="state.queryParams.PageIndex"
			v-model:page-size="state.queryParams.PageSize"
			:disabled="state.loading"
		/>
		<template #footer>
			<span class="dialog-footer">
				<el-button @click="dialogVisible = false" class="default-button">取 消</el-button>
				<el-button type="primary" @click="onSubmit" :disabled="!state.tableCheckbox">保 存</el-button>
			</span>
		</template>
	</el-dialog>
</template>

<script lang="ts" setup>
import { defineAsyncComponent, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { formatDate } from '@/utils/formatTime';
import {getCoursewareData} from '@/api/courseware/index';

const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页

// 定义子组件向父组件传值/事件
const emit = defineEmits(['choose']);

// 定义变量内容
const state = reactive({
	tableData: [] as any [], // 表格数据
	total: 0, // 总条数
	loading: false, // 加载
	queryParams: {
		PageIndex: 1, // 当前页
		PageSize: 10, // 每页条数
		name: null, // 关键字
	},
	tableCheckbox: [] as any[], // 选择的ID
});
const ruleDialogFormRef = ref<FormInstance>(); // 表单
const dialogVisible = ref(false); // 弹窗

// 打开弹窗
const openDialog = async (row: any[]) => {
	dialogVisible.value = true;
    console.log(row)
	try {
        if (row) {
			state.tableCheckbox = row;
		} else {
			state.tableCheckbox = [];
		}
		queryList();
	} catch (error) {
		console.log(error);
		state.loading = false;
	}
};
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
const tableRef = ref<RefType>();
const queryList = () => {
	state.loading = true;
	getCoursewareData(state.queryParams)
		.then((res: any) => {
			state.tableData = res.result?.items ?? [];
			state.total = res.result?.pagination.totalCount ?? 0;
			state.loading = false;
            const rows = [] as any[];
            state.tableCheckbox.forEach(item => {
                rows.push(state.tableData.find((it) => it.id === item.sourcewareId));
            })
            tableRef.value.setCheckboxRow(rows, true);
		})
		.catch(() => {
			state.loading = false;
		});
};
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	state.queryParams.name = null;
	handleQuery();
};
// 单个复选框点击
const checkboxChangeEvent = ({row}) => {
    let blog = 'add';
    state.tableCheckbox.forEach(item => {
        if(item.sourcewareId == row.id){
            blog = 'delete'
        }
    });
    if (blog == 'add'){
        state.tableCheckbox.push({sourcewareId: row.id, name: row.name})
    }else {
        state.tableCheckbox = state.tableCheckbox.filter(it => it.sourcewareId !== row.id )
    }
    console.log(state.tableCheckbox);
}
// 关闭弹窗
const closeDialog = () => {
	dialogVisible.value = false;
};
// 选择课件
const onSubmit = () => {
	emit('choose', state.tableCheckbox);
	closeDialog();
};
//暴漏变量和方法
defineExpose({ closeDialog, openDialog });
</script>
